/*=======================================================================*/
/* PressRoom Electronics, Inc.                                           */
/* Darrin Kohn 12/1/2002                                                 */
/* Junior new cpu (HC9S12A256B)                                          */
/*                                                                       */
/* Interrupt housekeeping functions                                      */
/* 42-035H0.c                                                            */
/*=======================================================================*/
#pragma CODE_SEG DEFAULT


void EEPROM_WRITE(volatile uint*,uint);

uint EEPROM_READ(volatile uint*);




#pragma CODE_SEG INTERRUPT_ROUTINES
#pragma TRAP_PROC
interrupt void RTI_INT(void);                               // come here when knob turned
/*======================================================================================================*/
/*======================================================================================================*/
interrupt void RTI_INT(void)                               // 5284
{

       _CRGFLG = 0x80;
       
       _ARMCOP = 0x55;
       _ARMCOP = 0xaa;                                     // reset the COP
       
        
       COUNTER++;
                                   
} // rti_int                                               // 52a1



#pragma CODE_SEG INTERRUPT_ROUTINES
#pragma TRAP_PROC
interrupt void KNOB_INT(void);                               // come here when knob turned
/*======================================================================================================*/
/*======================================================================================================*/
interrupt void KNOB_INT(void)                               // 52a2
{

           _PIFJ = 0xc0;                                    // 52a4  (0x26f)
             
           if (!(_PTJ & 0x40))                              // 52a7  (0x268)
           {
                if (TUNE==14)                               // 52b1  (0x8ee)
                {
                    DDS = DDS + 1000;                       // 52b6
                  
                }
                else DDS = DDS + 5;                         // 52be
               
           }
           else
           {
                if (TUNE==14)
                {
                    DDS = DDS - 1000;                       // 52d7
                     
                }
                else DDS = DDS - 5;                         // 52df
               
           }
                                                            // 52f1
    	   FREQ_CHANGE=1;  
   
                                   
} // knob_int                                              // 52f4


 


#pragma CODE_SEG DEFAULT

//======================================================================================================
// EEPROM write int                                                                                     
//======================================================================================================
void EEPROM_WRITE(volatile uint* EEADD,uint EEVAL)
{

 
        *EEADD = EEVAL;                         // 414E
        
        _ECMD = 0x60;                           // 4152 EEPROM word program  (0x116)
        _ESTAT = 0x80;									      	// 4157 EEPROM reset buffer flag (0x115)
        
   	   	for (;;)
        {
            if ((_ESTAT & _CCIF)) break;        // 415A
        }
	
    
}
   







//======================================================================================================
// EEPROM read int                                                                                      
//======================================================================================================
uint EEPROM_READ(volatile uint* EEADD)
{
    return(*EEADD);

}


 
 






#pragma CODE_SEG INTERRUPT_ROUTINES
#pragma TRAP_PROC
void Trap1(void);                                               // trap all unknown interrupts
                                      
/*--------------------------------------------*/
/* Trap all unintentional interrupts          */
/*--------------------------------------------*/                                      
interrupt void Trap1(void)
{
     
        asm SEI;                                                // turn off interrupts
      
        _PORTK = 0;                                             // shut off valve relays
        _PTT = 0;                                               // shut off valve relays
        _PTH = 0;                                               // turn off all PLS outputs
      
        _ARMCOP = 0x55;
        _ARMCOP = 0xaa;
      
                 
        for(;;)
        {
      
        _ARMCOP = 0x55;
        _ARMCOP = 0xaa;
        //do nothing
        }
}
  
#pragma CODE_SEG INTERRUPT_ROUTINES
#pragma TRAP_PROC
void Trap2(void);                                               // trap all unknown interrupts
 
  
/*--------------------------------------------*/
/* Trap all unintentional interrupts          */
/*--------------------------------------------*/                                      
interrupt void Trap2(void)
{
     
        asm SEI;                                                // turn off interrupts
      
        _PORTK = 0;                                             // shut off valve relays
        _PTT = 0;                                               // shut off valve relays
        _PTH = 0;                                               // turn off all PLS outputs
      
        _ARMCOP = 0x55;
        _ARMCOP = 0xaa;
      
                  
        for(;;)
        {
      
        _ARMCOP = 0x55;
        _ARMCOP = 0xaa;
        //do nothing
        }
}  
  

#pragma CODE_SEG INTERRUPT_ROUTINES
#pragma TRAP_PROC
      
void Trap3(void);                                               // trap all unknown interrupts
       
/*--------------------------------------------*/
/* Trap all unintentional interrupts          */
/*--------------------------------------------*/                                      
interrupt void Trap3(void)
{
     
        asm SEI;                                                // turn off interrupts
      
        _PORTK = 0;                                             // shut off valve relays
        _PTT = 0;                                               // shut off valve relays
        _PTH = 0;                                               // turn off all PLS outputs
      
        _ARMCOP = 0x55;
        _ARMCOP = 0xaa;
      
                  
        for(;;)
        {
      
        _ARMCOP = 0x55;
        _ARMCOP = 0xaa;
        //do nothing
        }
}  
 
#pragma CODE_SEG INTERRUPT_ROUTINES
#pragma TRAP_PROC
        
void Trap4(void);                                               // trap all unknown interrupts
        
/*--------------------------------------------*/
/* Trap all unintentional interrupts          */
/*--------------------------------------------*/                                      
interrupt void Trap4(void)
{
     
        asm SEI;                                                // turn off interrupts
      
        _PORTK = 0;                                             // shut off valve relays
        _PTT = 0;                                               // shut off valve relays
        _PTH = 0;                                               // turn off all PLS outputs
      
        _ARMCOP = 0x55;
        _ARMCOP = 0xaa;
      
                 
        for(;;)
        {
      
        _ARMCOP = 0x55;
        _ARMCOP = 0xaa;
        //do nothing
        }
}  			 
        
        
        